// ****************************************************************** 
//       * Functions triggered by events in client user interface
// ******************************************************************

var MAX_EVENTS = 100;
var jsEventData = new Array();

// ************************************************************************************
// Name   : newEvent()
// Purpose: newEvent constructor
// Inputs : 
// Outputs: NONE
function newEvent(aSequence, aWarning, aTime, aDate, anEvent)
{ 
   this.sequence = aSequence;              
   this.warning = aWarning;
   this.time = aTime;
   this.date = aDate;
   this.event = anEvent;
}

// ************************************************************************************
// Name   : buildEventData()
// Purpose: newEvent array constructor
// Inputs : 
// Outputs: NONE
function buildEventData(aSequence, aWarning, aTime, aDate, anEvent)
{ 
   if (jsEventData.length < MAX_EVENTS + 1)
      jsEventData[jsEventData.length] = new newEvent(aSequence, aWarning, aTime, aDate, anEvent);
}

// ************************************************************************************
// Sorting functions invoked by sortTable
function sortByWarning(a, b)
{
   a = a.warning.toLowerCase();
   b = b.warning.toLowerCase();
   return( a < b );
}

function sortByTime(a, b)
{
   var diff, dateA, dateB;
   if (a.time == b.time)
   {
      a = a.sequence;
      b = b.sequence;
      diff = a < b;
   }   
   else
   {
      dateA = new Date();
      dateB = new Date();
      dateA.setHours(a.time.substr(0, 2 ));
      dateA.setMinutes(a.time.substr(3, 2 ));
      dateA.setSeconds(a.time.substr(6, 2 ));
      dateB.setHours(b.time.substr(0, 2 ));
      dateB.setMinutes(b.time.substr(3, 2 ));
      dateB.setSeconds(b.time.substr(6, 2 ));
      diff = dateA < dateB;
   }
   return(diff);
}

function buildDate(aText)
{
   var mo, day, year;
   var reLong = /\b\d{1,2}[\/-]\d{1,2}[\/-]\d{4}\b/;
   var reShort = /\b\d{1,2}[\/-]\d{1,2}[\/-]\d{2}\b/;
   var valid = (reLong.test(aText)) || (reShort.test(aText));
   if (valid)
   {
      var delimChar = (aText.indexOf("/") != -1) ? "/" : "-";
      var delim1 = aText.indexOf(delimChar);
      var delim2 = aText.lastIndexOf(delimChar);
      mo = parseInt(aText.substring(0, delim1 ), 10);
      day = parseInt(aText.substring(delim1+1, delim2 ), 10);
      year = parseInt(aText.substring(delim2+1), 10);
      if (year < 100)
      {
         var today = new Date();
         var currCent = parseInt(today.getFullYear() / 100) * 100;
         var threshold = (today.getFullYear() + 15) - currCent;
         if (year > threshold)
            year += currCent - 100;
         else
            year += currCent;
      }

      var testDate = new Date(year, mo-1, day);
      if (testDate.getDate() == day)
      {
         if (testDate.getMonth() + 1 == mo)
         {
            if (testDate.getFullYear() == year)
               return( testDate );
         }
      }
   }
   return(0);
}

function sortByDate(a, b)
{
   var diff, dateA, dateB;
   if (a.date == b.date)
   {
      a = a.sequence;
      b = b.sequence;
      diff = a < b;
   }   
   else
   {
      dateA = buildDate(a.date);
      dateB = buildDate(b.date);
      if ((dateA == 0) || (dateB == 0))
         diff = 0;
      else
         diff = dateA < dateB;
   }
   return(diff);
}

function sortByEvent(a, b)
{
   var eventA = a.event.toLowerCase();
   var eventB = b.event.toLowerCase();
   return( eventA < eventB );
}

// Remove existing table rows
function clearTable(tbody)
{
   while (tbody.rows.length > 0)
   {
      tbody.deleteRow(0);
   }
}

// Draw table from 'jsEventData' array of objects
function drawTable(tbody)
{
   var tr, td, anImage;

   tbody = Get_Iframe_Element( tbody ) ;
   if (tbody)
   {  
      var columnIds = ["warningColumn", "timeColumn", "dateColumn", "eventColumn"];
      // Remove existing rows, if any
      clearTable(tbody);
      // Loop through data source
      for (var i = 0; i < jsEventData.length; i++)
      {
         tr = tbody.insertRow(tbody.rows.length);
         td = tr.insertCell(tr.cells.length);
         td.setAttribute("id", columnIds[tr.cells.length-1]);
/*         if (jsEventData[i].warning == "R")
         {
            anImage = document.createElement("img");
            anImage.setAttribute("src", "../images/icons/redwarning.png");
            td.appendChild(anImage);
         } 
*/
/* 
         see eventlog.h enum WarningLevel
*/
         if (jsEventData[i].warning == "1")
         {
            td.innerHTML = "D";
         }
         else if (jsEventData[i].warning == "2")
         {
            td.innerHTML = "D";
         }
         else if (jsEventData[i].warning == "3")
         {
            td.innerHTML = "D";
         }
         else if (jsEventData[i].warning == "4")        
         {
            td.innerHTML = "I";
         }
         else if (jsEventData[i].warning == "5")
         {
            td.setAttribute("id", "yellowWarning");
            td.innerHTML = "Y";
         }
         else if (jsEventData[i].warning == "6")
         {
            td.setAttribute("id", "redWarning");
            td.innerHTML = "R";
         }
         else if (jsEventData[i].warning == "7")
         {
            td.setAttribute("id", "redWarning");
            td.innerHTML = "R";
         }

         td = tr.insertCell(tr.cells.length);
         td.setAttribute("id", columnIds[tr.cells.length-1]);
         td.innerHTML = jsEventData[i].time;

         td = tr.insertCell(tr.cells.length);
         td.setAttribute("id", columnIds[tr.cells.length-1]);
         td.innerHTML = jsEventData[i].date;

         td = tr.insertCell(tr.cells.length);
         td.setAttribute("id", columnIds[tr.cells.length-1]);
         td.innerHTML = jsEventData[i].event;
      }
   }
}

// Sorting function dispatcher invoked by table comuln links
function sortTableByWarning()
{
   insertSort(jsEventData, sortByWarning);  //jsEventData.sort(sortByWarning);
   drawTable("eventData");
   return(false);
}

function insertSort(arrayData, pSortFunction)
{
   var i, j;
   var temp;

   for (i=1; i < arrayData.length; i = i + 1)
   {
      temp = arrayData[i];  // Insert the ith element into the sorted array
      j = i - 1;                           // Find where new element goes
      while ( ( j >= 0) && (pSortFunction(temp, arrayData[j])) )
      {
         arrayData[j+1] = arrayData[j];    // Not here
         j = j - 1;
      }
      arrayData[j+1] = temp;
   }
}

function sortTable(link)
{
   switch (link.firstChild.nodeValue)
   {
      case "Warning" : insertSort(jsEventData, sortByWarning); break;
      case "Time"    : insertSort(jsEventData, sortByTime); break;   
      case "Date"    : insertSort(jsEventData, sortByDate); break;   
      case "Event"   : insertSort(jsEventData, sortByEvent); break;  
   }
   drawTable("eventData");
   return(false);
}

// ************************************************************************************
// Name   : client_SetMonEventBufferDeleteAll()
// Purpose: Called when user wants to delete all events.
// Inputs : anEvent
// Outputs: NONE
function client_SetMonEventBufferDeleteAll()
{
   if (IsChangeConfirmed("Delete All Events"))
   {
      deleteAllEventsCount = deleteAllEventsCount + 1;
      serverMonEventBufferIntf.SetMonEventBufferDeleteAll(deleteAllEventsCount);
      Focus_Iframe();
   }                           
   setTimeout("RefreshIframe();", 250);
};

// ************************************************************************************
// Name   : client_SetMonEventBufferStatusUpdate()
// Purpose: Called when the current iFrame loads
// Inputs : NONE
// Outputs: NONE
function client_SetMonEventBufferStatusUpdate()
{
   serverMonEventBufferIntf.SetMonEventBufferStatusUpdate();
};


// ****************************************************************** 
// * Functions called asynchronously from the server.
// ******************************************************************

function asyncUpdateMonEventBufferStatus(eventBuffer)
{
   aBlock = Get_Iframe_Element( "eventData" ) ;
   if (aBlock)
   {  
      var aWarning, aTime, aDate, anEvent;
      var dbContent = eventBuffer.split("\n");
      if ( dbContent.length )
      {
         jsEventData = new Array();
         for (var i = 0; i < dbContent.length -1; i++)
         {
            aSeqNumber = dbContent[i].split(",")[0];
            aWarning = dbContent[i].split(",")[1];
            aTime = dbContent[i].split(",")[2];
            aDate = dbContent[i].split(",")[3];
            anEvent = dbContent[i].split(",")[4];
            buildEventData(aSeqNumber, aWarning, aTime, aDate, anEvent);
         }
         drawTable("eventData");
      }
   }
   evIsConnected = true;     
}


