var iFrameLink;
var gnavNameSelected;

var LED_OFF = 0;
var LED_ON = 1;

var MASK = 0;
var UNMASK = 1;

var NO = 0;
var YES = 1;

var isDebugMode = 0;

// Installed options
var bIsTerrEthFpgaBridge = 0;
var bIsTerrEthFpgaDTV = 0;                
var bIsTerrEthRevertAuto = 0;             
var bIsTerrEthCardActive = 0;             
var bIsTerrEthCardInstalled = 0;          
var bIsBackupIpMulticast = 0;             
var bIsPrimeIpMulticast = 0;              
var bIsFlashFile = 0;                     
var bIsPcrRestampingAllowed = 0;          
var bIsRedundancyMultiPiicMode = 0;       
var bIsManualMultiPiicMode = 0;           
var bIsPhaseNoiseGeneratorDisplayable = 0;
var bIsPiicDisplayable = 0;               
var bIsAutoEqCardInstalled = 0;

var bFeatureSr68MspsInstalled = 0;
var bFeatureSr45MspsInstalled = 0;
var bFeatureSr20MspsInstalled = 0;
var bFeatureSr10MspsInstalled = 0;
var bFeatureSr5MspsInstalled = 0;
var bFeatureSr1MspsInstalled = 0;
var bFeature32ApskInstalled = 0;
var bFeature16ApskInstalled = 0;
var bFeature16QamInstalled = 0;
var bFeature8PskInstalled = 0;
var bFeatureQpskInstalled = 0;
var bFeatureBpskInstalled = 0;
var bFeatureAutoEqRemoteServerInstalled = 0;
var bFeatureAutoEqRemoteClientInstalled = 0;
var bFeatureAutoEqInstalled = 0;
var bFeatureLbandInstalled = 0;
var bFeatureIfInstalled = 0;
var bFeatureNetworkSpecAcmInstalled = 0;
var bFeatureNetworkSpecDtvAmcInstalled = 0;
var bFeatureNetworkSpecDvbS2CcmInstalled = 0;
var bFeatureNetworkSpecDtvSatInstalled = 0;
var bFeatureNetworkSpecDpcSatInstalled = 0;
var bFeatureNetworkSpecDavicMmdsInstalled = 0;
var bFeatureNetworkSpecDavicCableInstalled = 0;
var bFeatureNetworkSpecDvbSatInstalled = 0;
var bFeatureNetworkSpecDvbCableInstalled = 0;
var bFeatureClosedNetworkSpecInstalled = 0;

var slot1InterfaceBoardType = 0;
var slot2InterfaceBoardType = 0;
var slot3InterfaceBoardType = 0;
var modemType = 0;
var userConfirmation = 0;
var featureDemoCount = 0;
var deleteAllEventsCount = 0;

function Initialize_Monitor_Site() 
{
   // Initialize the event handler
   Initialize_Site();

   // Preload images into the browser for fast updates
   preloadImages();

   // Hide unused Led images
   Hide_Led_Images();

   // Load iFrame
   gnavNameSelected = 'gnavTransmit';
   buildButtons();

   UpdateIframe("xmitif.htm", "inlineFrameId", gnavNameSelected);
};

function Get_Target( anEvent )
{
   anEvent = (anEvent) ? anEvent : ((window.event) ? event : null);
   var target = (anEvent.target) ? anEvent.target : anEvent.srcElement;
   return target;
}

function Hide_Element(elementId)
{
   var anElement;

   anElement = document.getElementById(elementId);
   if ( anElement )
      anElement.style.visibility='hidden';
}

function Show_Element(elementId)
{
   var anElement;

   anElement = document.getElementById(elementId);
   if ( anElement )
      anElement.style.visibility='visible';
}

function Update_Element_Select_Content( anElement, aSelectContent)
{
   if ( anElement )
   {
      var dbContent = aSelectContent.split("\n");
      anElement.options.length = 0;
      if ( dbContent.length )
      {
         var isSelected;
         for (var i = 0; i < dbContent.length -1; i++)
         {
            isSelected = parseInt(dbContent[i].split(",")[2]);
            anElement.options[i] = new Option(dbContent[i].split(",")[0], 
                                           dbContent[i].split(",")[1], 
                                           false, 
                                           isSelected);
         }
      }
   }
}

function Update_Transmit_On_Led(isLedOn)
{
   if (isLedOn)
   {
      Hide_Element('modTransmitOnDarkLed');
      Show_Element('modTransmitOnGreenLed');
   }
   else
   {
      Show_Element('modTransmitOnDarkLed');
      Hide_Element('modTransmitOnGreenLed');
   }
}

function Update_Transmit_Major_Alarm_Led(isLedOn)
{
   if (isLedOn)
   {
      Hide_Element('modMajorAlarmDarkLed');
      Show_Element('modMajorAlarmRedLed');
   }
   else
   {
      Show_Element('modMajorAlarmDarkLed');
      Hide_Element('modMajorAlarmRedLed');
   }
}

function Update_Transmit_Minor_Alarm_Led(isLedOn)
{
   if (isLedOn)
   {
      Hide_Element('modMinorAlarmDarkLed');
      Show_Element('modMinorAlarmYellowLed');
   }
   else
   {
      Show_Element('modMinorAlarmDarkLed');
      Hide_Element('modMinorAlarmYellowLed');
   }
}

function Update_Transmit_Test_Mode_Led(isLedOn)
{
   if (isLedOn)
   {
      Hide_Element('modTestModeDarkLed');
      Show_Element('modTestModeYellowLed');
   }
   else
   {
      Show_Element('modTestModeDarkLed');
      Hide_Element('modTestModeYellowLed');
   }
}

function Update_Common_Power_Led(isLedOn)
{
   if (isLedOn)
   {
      Hide_Element('powerDarkLed');
      Show_Element('powerGreenLed');
   }
   else
   {
      Show_Element('powerDarkLed');
      Hide_Element('powerGreenLed');
   }
}

function Update_Common_Fault_Led(isLedOn)
{
   if (isLedOn)
   {
      Hide_Element('faultDarkLed');
      Show_Element('faultRedLed');
   }
   else
   {
      Show_Element('faultDarkLed');
      Hide_Element('faultRedLed');
   }
}

function Update_Common_Event_Led(isLedOn)
{
   if (isLedOn)
   {
      Hide_Element('eventDarkLed');
      Show_Element('eventYellowLed');
   }
   else
   {
      Show_Element('eventDarkLed');
      Hide_Element('eventYellowLed');
   }
}

function Update_Common_Remote_Led(isLedOn)
{
   if (isLedOn)
   {
      Hide_Element('remoteDarkLed');
      Show_Element('remoteGreenLed');
   }
   else
   {
      Show_Element('remoteDarkLed');
      Hide_Element('remoteGreenLed');
   }
}

function Hide_Led_Images()
{
   Update_Transmit_On_Led(LED_OFF);              
   Update_Transmit_Major_Alarm_Led(LED_OFF);     
   Update_Transmit_Minor_Alarm_Led(LED_OFF);     
   Update_Transmit_Test_Mode_Led(LED_OFF);       
 
   Update_Common_Power_Led(LED_OFF);             
   Update_Common_Fault_Led(LED_OFF);             
   Update_Common_Event_Led(LED_OFF);             
   Update_Common_Remote_Led(LED_OFF);            
}

// ****************************************************************** 
//       * Functions triggered by events in client user interface
// ******************************************************************

// ****************************************************************** 
// * Functions called asynchronously from the server.
// ******************************************************************
function asyncUpdateMonitorTxLedStatus(aTransmitOnLed, aTxMajorAlarmLed, aTxMinorAlarmLed, aTxTestModeLed)
{
   Update_Transmit_On_Led(aTransmitOnLed);                // Update transmit On Led
   Update_Transmit_Major_Alarm_Led(aTxMajorAlarmLed);     // Update transmit major alarm Led
   Update_Transmit_Minor_Alarm_Led(aTxMinorAlarmLed);     // Update transmit minor alarm Led
   Update_Transmit_Test_Mode_Led(aTxTestModeLed);         // Update transmit test mode Led
}

function asyncUpdateMonitorSysLedStatus(aPowerLed, aFaultLed, anEventLed, aRemoteLed)
{
   Update_Common_Power_Led(aPowerLed);                    // Update the Power Led
   Update_Common_Fault_Led(aFaultLed);                    // Update the Fault Led
   Update_Common_Event_Led(anEventLed);                   // Update the Event Led
   Update_Common_Remote_Led(aRemoteLed);                  // Update the Remote Led
}

function asyncUpdateMonitorSetErrorStatus(sysSetError)
{
   if ( sysSetError )
   {  // Error during SET operation
      alert( "ERROR PROCESSING COMMAND!!!" );
      RefreshIframe();          // Reload current iFrame
   }
}

function asyncUpdateMonitorInstalledFeaturesStatus( installedFeatures )
{
   bFeatureSr68MspsInstalled                = (installedFeatures & 0x04000000) ? true : false;
   bFeatureSr45MspsInstalled                = (installedFeatures & 0x02000000) ? true : false;
   bFeatureSr20MspsInstalled                = (installedFeatures & 0x01000000) ? true : false;

   bFeatureSr10MspsInstalled                = (installedFeatures & 0x00800000) ? true : false;
   bFeatureSr5MspsInstalled                 = (installedFeatures & 0x00400000) ? true : false;
   bFeatureSr1MspsInstalled                 = (installedFeatures & 0x00200000) ? true : false;
   bFeature32ApskInstalled                  = (installedFeatures & 0x00100000) ? true : false;
   bFeature16ApskInstalled                  = (installedFeatures & 0x00080000) ? true : false;
   bFeature16QamInstalled                   = (installedFeatures & 0x00040000) ? true : false;
   bFeature8PskInstalled                    = (installedFeatures & 0x00020000) ? true : false;
   bFeatureQpskInstalled                    = (installedFeatures & 0x00010000) ? true : false;

   bFeatureBpskInstalled                    = (installedFeatures & 0x00008000) ? true : false;
   bFeatureAutoEqRemoteServerInstalled      = (installedFeatures & 0x00004000) ? true : false;
   bFeatureAutoEqRemoteClientInstalled      = (installedFeatures & 0x00002000) ? true : false;
   bFeatureAutoEqInstalled                  = (installedFeatures & 0x00001000) ? true : false;
   bFeatureLbandInstalled                   = (installedFeatures & 0x00000800) ? true : false;
   bFeatureIfInstalled                      = (installedFeatures & 0x00000400) ? true : false;
   bFeatureNetworkSpecAcmInstalled          = (installedFeatures & 0x00000200) ? true : false;
   bFeatureNetworkSpecDtvAmcInstalled       = (installedFeatures & 0x00000100) ? true : false;

   bFeatureNetworkSpecDvbS2CcmInstalled     = (installedFeatures & 0x00000080) ? true : false;
   bFeatureNetworkSpecDtvSatInstalled       = (installedFeatures & 0x00000040) ? true : false;
   bFeatureNetworkSpecDpcSatInstalled       = (installedFeatures & 0x00000020) ? true : false;
   bFeatureNetworkSpecDavicMmdsInstalled    = (installedFeatures & 0x00000010) ? true : false;
   bFeatureNetworkSpecDavicCableInstalled   = (installedFeatures & 0x00000008) ? true : false;
   bFeatureNetworkSpecDvbSatInstalled       = (installedFeatures & 0x00000004) ? true : false;
   bFeatureNetworkSpecDvbCableInstalled     = (installedFeatures & 0x00000002) ? true : false;
   bFeatureClosedNetworkSpecInstalled       = (installedFeatures & 0x00000001) ? true : false;
}

function asyncUpdateMonitorActiveFeaturesStatus( activeFeatures )
{
   bIsAutoEqCardInstalled             = (activeFeatures & 0x00020000) ? true : false;
   bIsTerrEthCardInstalled            = (activeFeatures & 0x00010000) ? true : false;

   bIsTerrEthFpgaBridge               = (activeFeatures & 0x00008000) ? true : false;
   bIsTerrEthFpgaDTV                  = (activeFeatures & 0x00004000) ? true : false;
   bIsTerrEthRevertAuto               = (activeFeatures & 0x00002000) ? true : false;
   bIsTerrEthCardActive               = (activeFeatures & 0x00001000) ? true : false;
   bIsBackupIpMulticast               = (activeFeatures & 0x00000800) ? true : false;
   bIsPrimeIpMulticast                = (activeFeatures & 0x00000400) ? true : false;
   bIsFlashFile                       = (activeFeatures & 0x00000200) ? true : false;
   bIsPcrRestampingAllowed            = (activeFeatures & 0x00000100) ? true : false;

   bIsRedundancyMultiPiicMode         = (activeFeatures & 0x00000080) ? true : false;
   bIsManualMultiPiicMode             = (activeFeatures & 0x00000040) ? true : false;
   bIsPhaseNoiseGeneratorDisplayable  = (activeFeatures & 0x00000020) ? true : false;
   bIsPiicDisplayable                 = (activeFeatures & 0x00000010) ? true : false;
   bIsDtvAmcNetworkSpecActive         = (activeFeatures & 0x00000008) ? true : false;
   bIsAcmNetworkSpecActive            = (activeFeatures & 0x00000004) ? true : false;
   bIsCcmNetworkSpecActive            = (activeFeatures & 0x00000002) ? true : false;
   bIsDvbS2DtvAmcNetworkSpecActive    = (activeFeatures & 0x00000001) ? true : false;
}

function asyncUpdateMonitorTerrInterfaceStatus( slot1Interface, slot2Interface, slot3Interface )
{
   slot1InterfaceBoardType = slot1Interface;
   slot2InterfaceBoardType = slot2Interface;
   slot3InterfaceBoardType = slot3Interface;
}

function asyncUpdateMonitorModemTypeStatus(aModemType)
{
   modemType = aModemType;
   evIsConnected = true;               // Flag persistent connection is established
}

function asyncUpdateMonitorUserConfirmationStatus(aUserConfirmation)
{
   userConfirmation = aUserConfirmation;
}

function asyncUpdateSetPreferencesUserConfirmationStatus(aUserConfirmation)
{
   userConfirmation = aUserConfirmation;
}

function asyncUpdateMonitorEventBufferDeleteAllCountStatus(aDeleteAllEventsCount)
{
   deleteAllEventsCount = aDeleteAllEventsCount;
}

function RefreshIframe()
{
   if ( iFrameLink )
      UpdateIframe(iFrameLink, "inlineFrameId", gnavNameSelected);
}

function OpenPdfWindow(aPdfFile)
{
   var aPdfWindow = window.open(aPdfFile, "pdfWindow",
        "scrollbars=yes,resizable=yes,location=no,width=750,height=650");
   aPdfWindow.focus();
}

function OpenContactWindow(aLink)
{
   var aContactWindow = window.open(aLink, "contactWindow",
        "toolbar=yes,scrollbars=yes,resizable=yes,width=825,height=650");
   aContactWindow.focus();
}

function OpenGraphWindow(aLink, navName)
{
   var aGraphWindow = window.open(aLink, "graphWindow",
        "toolbar=no,scrollbars=no,resizable=no,width=550,height=400");
   aGraphWindow.focus();
}