// ****************************************************************** 
//       * Functions triggered by events in client user interface
// ******************************************************************

// ************************************************************************************
// Name   : client_SetPreferencesSiteStatusUpdate()
// Purpose: Called when the current page loads
// Inputs : NONE
// Outputs: NONE
function client_SetPreferencesSiteStatusUpdate()
{
   Initialize_SetPreferencesSite();
   serverSetPreferencesIntf.SetPreferencesSelectContentUpdate();
   serverSetPreferencesIntf.SetPreferencesStatusUpdate();
};


// ****************************************************************** 
// * Functions called asynchronously from the server.
// ******************************************************************

function asyncUpdateSetPreferencesUserConfirmationStatus(aUserConfirmation)
{
   var anElement = document.getElementById( 'confirmationSelect' );
   if ( anElement )	        // Set user confirmation
      anElement.value = aUserConfirmation;
   userConfirmation = aUserConfirmation;
}

function asyncUpdateSetPreferencesWebAuthProtocolStatus(aWebAuthProtocol)
{
   var anElement = document.getElementById( 'authenticationSelect' );
   if ( anElement )	        // Set authentication protocol
      anElement.value = aWebAuthProtocol;
}

// ****************************************************************** 
// * Functions to update the select content.
// ******************************************************************

function asyncUpdateSetPreferencesUserConfirmationSelectContent(aSelectContent)
{
   var anElement = document.getElementById('confirmationSelect');
   if ( anElement )
      Update_Element_Select_Content( anElement, aSelectContent );
}

function asyncUpdateSetPreferencesWebAuthProtocolSelectContent(aSelectContent)
{
   var anElement = document.getElementById('authenticationSelect');
   if ( anElement )
      Update_Element_Select_Content( anElement, aSelectContent );
}

