//  These are references to instances of the auto-generated interface 
//  ex: a reference to the SC2SIntf class in the SC2SIntf.js JavaScript file.
var serverXmitIfIntf; 
var serverXmitEqIntf; 

var serverIntfTxSetupIntf; 
var serverTxEthernetIntf;

var serverRfSwitchIntf;

var serverMonVoltIntf;          
var serverMonEventBufferIntf; 
var serverMonEthernetIntf;          

var serverAlarmTxIntf; 

var serverSysTermIntf; 
var serverSysConfIntf; 
var serverSysFeatrIntf; 
var serverSysBackChannelIntf; 
var serverCarrIdIntf; 

var serverTestCarIntf; 

var serverSetIpIntf; 

var serverSetPwdIntf; 
var serverSetPreferencesIntf; 
var serverSetAppIntf; 

// EventHandler 
var eh;

var evIsConnected = false; 

var isIE;
var isNav;
var isOpera;
var isWin;
var isMacOS;
var isUnix;

var isIE5Min;
var isNN6Min;

var stdBrowser;
var screenAvailWidth;
var screenAvailHeight;

// Menu items
var menuitem1;
var menuitem2;
var menuitem3;
var menuitem4;
var menuitem5;

// ************************************************************************************
// Name   : isStandardsCompliantBrowser()
// Purpose: Checks if the browser is compliant with the standards. Browsers such as
//          Internet Expoler 5.x or Netscape 6 or later are compliant.
// Inputs : NONE
// Outputs: NONE
function isStandardsCompliantBrowser()
{
   if (document.getElementById)
      return (true);
   else
      return (false);
}

// ************************************************************************************
// Name   : getInternetExplorerVersionNumber()
// Purpose: Check what the minimum version of Internet Explorer is
// Inputs : NONE
// Outputs: NONE
function getInternetExplorerVersionNumber()
{
   var userAgent = navigator.userAgent;
   var offsetMSIE = userAgent.indexOf("MSIE ");
   if (offsetMSIE == -1)
      return (0);
   else
      return (parseFloat(userAgent.substring(offsetMSIE + 5, userAgent.indexOf(";", offsetMSIE))));
}

// ************************************************************************************
// Name   : getNetscapeNavigatorVersionNumber()
// Purpose: Check what the minimum version of Netscape Navigator is
// Inputs : NONE
// Outputs: NONE
function getNetscapeNavigatorVersionNumber()
{
   if (navigator.appName == "Netscape")
   {
      var appVer = parseFloat(navigator.appVersion);
      if (appVer < 5)
         return (appVer);
      else
      {
         if (typeof navigator.vendorSub != "undefined")
            return (parseFloat(navigator.vendorSub));
      }
   }
}

// ************************************************************************************
// Name   : Initialize_Browser_Feature_Detection()
// Purpose: Intialize the browser specific information
// Inputs : 
// Outputs: NONE
function Initialize_Browser_Feature_Detection()
{
   // Updates if browser is standards compliant
   stdBrowser = isStandardsCompliantBrowser();

   // Detect the browser brand
   isIE = (navigator.appName == "Microsoft Internet Explorer");
   isNav = (navigator.appName == "Netscape");
   isOpera = (navigator.userAgent.indexOf("Opera") != -1);

   // Detect the client operating system
   isWin = (navigator.userAgent.indexOf("Win") != -1);
   isMacOS = (navigator.userAgent.indexOf("Mac") != -1);
   isUnix = (navigator.userAgent.indexOf("X11") != -1);

   // Detect an early browser version
   isIE5Min = getInternetExplorerVersionNumber() >= 5;
   isNN6Min = getNetscapeNavigatorVersionNumber() >= 6;
}

// ************************************************************************************
// Name   : Initialize_Browser()
// Purpose: 
// Inputs : 
// Outputs: NONE
function Initialize_Browser() 
{
   var width;
   var height;

   // Intialize the browser specific information
   Initialize_Browser_Feature_Detection();
   screenAvailWidth = screen.availWidth;
   screenAvailHeight = screen.availHeight;

   if (screenAvailWidth <= 875 || screenAvailHeight <= 750)
   {
      width = screenAvailWidth;
      height = screenAvailHeight;
      // Resize main window
      if ( window )
      {  // Make sure the window is defined. Avoid race condition
         window.resizeTo( width, height );
         window.focus();
      }
   }
};

// *************************************************************************************
// Name   :	startMonitorEH()
// Purpose: Create one instance of the Persistent bi-directional
//          asynchronous communication stack. The argument to the
//          constructor is the path to where we have installed the
//          "WebInterface" server side interface.
// Inputs : NONE
// Outputs: NONE
function startMonitorEH() 
{
   eh = new EventHandler("/WebInterface.interface");

   // Create instances of our client to server interfaces and bind the interfaces to the EventHandler.
   serverXmitIfIntf = new C2SXmtIf(eh);
   serverXmitEqIntf = new C2SXmtEq(eh);

   serverIntfTxSetupIntf = new C2SIntTx(eh);
   serverTxEthernetIntf = new C2SEth(eh);

   serverRfSwitchIntf = new C2SRfSw(eh);

   serverMonVoltIntf = new C2SMonVt(eh);
   serverMonEventBufferIntf = new C2SMonEb(eh);
   serverMonEthernetIntf = new C2SMonEt(eh);

   serverAlarmTxIntf = new C2SAlmTx(eh);

   serverSysTermIntf = new C2SSysTe(eh);
   serverSysConfIntf = new C2SSysCg(eh);
   serverSysFeatrIntf = new C2SSysFe(eh);
   serverSysBackChannelIntf = new C2SSysBk(eh);
   serverCarrIdIntf = new C2SSysId(eh);

   serverTestCarIntf = new C2STestC(eh);
}

function startSetIpEH() 
{
   eh = new EventHandler("/WebInterface.interface");

   // Create instances of our client to server interfaces and bind the interfaces to the EventHandler.
   serverSetIpIntf = new C2SSetIp(eh);
}

function startSetPwdEH() 
{
   eh = new EventHandler("/WebInterface.interface");

   // Create instances of our client to server interfaces and bind the interfaces to the EventHandler.
   serverSetPwdIntf = new C2SSetPw(eh);
}

function startSetPreferencesEH() 
{
   eh = new EventHandler("/WebInterface.interface");

   // Create instances of our client to server interfaces and bind the interfaces to the EventHandler.
   serverSetPreferencesIntf = new C2SSetPr(eh);
}

function startSetAppEH() 
{
   eh = new EventHandler("/WebInterface.interface");

   // Create instances of our client to server interfaces and bind the interfaces to the EventHandler.
   serverSetAppIntf = new C2SSetAp(eh);
}

// ************************************************************************************
function Initialize_Site() 
{
   Initialize_Browser();
   // Create one instance of the Persistent bi-directional asynchronous communication stack. 
   startMonitorEH();
};

// ************************************************************************************
function Initialize_SetIpSite() 
{
   Initialize_Browser();
   // Create one instance of the Persistent bi-directional asynchronous communication stack. 
   startSetIpEH();
};

// ************************************************************************************
function Initialize_SetPwdSite() 
{
   Initialize_Browser();
   // Create one instance of the Persistent bi-directional asynchronous communication stack. 
   startSetPwdEH();
};

// ************************************************************************************
function Initialize_SetPreferencesSite() 
{
   Initialize_Browser();
   // Create one instance of the Persistent bi-directional asynchronous communication stack. 
   startSetPreferencesEH();
};

// ************************************************************************************
function Initialize_SetAppSite() 
{
   Initialize_Browser();
   // Create one instance of the Persistent bi-directional asynchronous communication stack. 
   startSetAppEH();
};

// ************************************************************************************
// Name   : linkDown()
// Purpose: TEMPOARARY SOLUTION. The LinkHandler (eh) calls this if the
//          link goes down. Works with IE only
// Inputs : 
// Outputs: NONE
function linkDown()
{
   evIsConnected = false;

   // A BUG in IE prevents us from directly calling
   // resetEventHandler. This function is run in the context of
   // the EH iframe, which causes the browser to crash if a new
   // iframe connection is setup from within the iframe itself.
   setTimeout("resetEventHandler();", 100);

   setTimeout("checkLinkHandlerCon()", 3000);
}

// ************************************************************************************
// Name   :	checkLinkHandlerCon()
// Purpose: 
// Inputs : 
// Outputs: NONE
function checkLinkHandlerCon()
{
   if(evIsConnected)
      return;
   alert("Unable to establish a persistent server connection.\n\nLogout then Re-Start a new Session.");
   setTimeout("checkLinkHandlerCon()", 5000);
}

// ************************************************************************************
// Name   : resetEventHandler()
// Purpose: TEMPOARARY SOLUTION. Make the internal EH object reconnect the
//          persistent connection
// Inputs : 
// Outputs: NONE
function resetEventHandler()
{
   eh.cef = 0;
   var src = eh.ef[0].iFr.src;
   eh.ef[0].iFr.src = src;
}

// ************************************************************************************
// Name   : IsBandwidthChangeConfirmed()
// Purpose: Checks whether the bandwidth change is confirmed
// Inputs : aText
// Outputs: false = Not confirmed, true = Confirmed
function IsBandwidthChangeConfirmed(aText)
{
   var confirmed;
   if (confirm( aText + " (Bandwidth) Change.\n\nDo You Want to Proceed?" ))
      confirmed = true;
   else
   {
      confirmed = false;
      setTimeout("RefreshIframe();", 250);
   }
   return(confirmed);
}

// ************************************************************************************
// Name   : IsChangeConfirmed()
// Purpose: Checks whether the user wants to confirm all changes
// Inputs : aText
// Outputs: false = Not confirmed, true = Confirmed
function IsChangeConfirmed(aText)
{
   var confirmed;
   if (userConfirmation)
   {
      if (confirm( aText + " Change.\n\nDo You Want to Proceed?" ))
         confirmed = true;
      else
      {
         confirmed = false;
         setTimeout("RefreshIframe();", 250);
      }
   }
   else
      confirmed = true;
   return(confirmed);
}
