// ****************************************************************** 
function client_SetBackChannelLocalPort(anEvent)
{
   anEvent = (anEvent) ? anEvent : event;
   var charCode = (anEvent.charCode) ? anEvent.charCode : 
                  ((anEvent.which) ? anEvent.which : anEvent.keyCode);
   if (charCode == 13 || charCode == 3)
   {
      var anElement = Get_Iframe_Element( 'BackChannelLocalPortInput' ) ;
      if ( anElement )
      {
         if (IsNumber(anElement))
         {
            if (IsChangeConfirmed("Back Channel Local Port"))
            {
               serverSysBackChannelIntf.SetBackChannelLocalPort(parseInt(anElement.value, 10));
               Focus_Iframe();
            }
         }
      }
   }
};

function client_SetBackChannelServerPort(anEvent)
{
   anEvent = (anEvent) ? anEvent : event;
   var charCode = (anEvent.charCode) ? anEvent.charCode : 
                  ((anEvent.which) ? anEvent.which : anEvent.keyCode);
   if (charCode == 13 || charCode == 3)
   {
      var anElement = Get_Iframe_Element( 'BackChannelServerPortInput' ) ;
      if ( anElement )
      {
         if (IsNumber(anElement))
         {
            if (IsChangeConfirmed("Back Channel Server Port"))
            {
               serverSysBackChannelIntf.SetBackChannelServerPort(parseInt(anElement.value, 10));
               Focus_Iframe();
            }
         }
      }
   }
};

function client_SetBackChannelServerIpAddress(anEvent)
{
   anEvent = (anEvent) ? anEvent : event;
   var charCode = (anEvent.charCode) ? anEvent.charCode : 
                  ((anEvent.which) ? anEvent.which : anEvent.keyCode);
   if (charCode == 13 || charCode == 3)
   {
      var anElement = Get_Iframe_Element( 'BackChannelServerIpAddressInput' ) ;
      if ( anElement )
      {
         if (IsValidIpAddress(anElement))
         {
            if (IsChangeConfirmed("BackChannel Server IP Address"))
            {
               serverSysBackChannelIntf.SetBackChannelServerIpAddress(anElement.value);
               Focus_Iframe();
            }
         }
      }
   }                          
};

function client_SetBackChannelReceiveTimeout(anEvent)
{
   anEvent = (anEvent) ? anEvent : event;
   var charCode = (anEvent.charCode) ? anEvent.charCode : 
                  ((anEvent.which) ? anEvent.which : anEvent.keyCode);
   if (charCode == 13 || charCode == 3)
   {
      var anElement = Get_Iframe_Element( 'BackChannelReceiveTimeoutInput' ) ;
      if ( anElement )
      {
         if (IsNumber(anElement))
         {
            if (IsChangeConfirmed("Back Channel Receive Timeout"))
            {
               var aTimeout = parseFloat(anElement.value);
               anElement.value = FormatNumber(aTimeout, 1);
               serverSysBackChannelIntf.SetBackChannelReceiveTimeout(aTimeout * 10);
               Focus_Iframe();
            }
         }
      }
   }
};

function client_SetBackChannelReplyTimeout(anEvent)
{
   anEvent = (anEvent) ? anEvent : event;
   var charCode = (anEvent.charCode) ? anEvent.charCode : 
                  ((anEvent.which) ? anEvent.which : anEvent.keyCode);
   if (charCode == 13 || charCode == 3)
   {
      var anElement = Get_Iframe_Element( 'BackChannelReplyTimeoutInput' ) ;
      if ( anElement )
      {
         if (IsNumber(anElement))
         {
            if (IsChangeConfirmed("Back Channel Reply Timeout"))
            {
               serverSysBackChannelIntf.SetBackChannelReplyTimeout(parseInt(anElement.value, 10));
               Focus_Iframe();
            }
         }
      }
   }
};

function client_SetSysBackChannelStatusUpdate()
{
   serverSysBackChannelIntf.SetSysBackChannelStatusUpdate();
};

// ****************************************************************** 
function asyncUpdateSysBackChannelLocalPortStatus(aLocalPort)
{
   var anElement = Get_Iframe_Element( 'BackChannelLocalPortInput' ) ;
   if ( anElement )	      // Set back channel local port
   {
      anElement.value = aLocalPort;
//      if ( bFeatureAutoEqRemoteClientInstalled && bFeatureAutoEqInstalled )
      if ( bFeatureAutoEqInstalled )
         anElement.disabled = false;
      else
         anElement.disabled = true;
   }
}

function asyncUpdateSysBackChannelServerPortStatus(aServerPort)
{
   var anElement = Get_Iframe_Element( 'BackChannelServerPortInput' ) ;
   if ( anElement )	      // Set back channel Server port
   {   
      anElement.value = aServerPort;
      if ( bFeatureAutoEqInstalled )
         anElement.disabled = false;
      else
         anElement.disabled = true;
   }
}

function asyncUpdateSysBackChannelServerIpAddressStatus(aServerIpAddress)
{
   var anElement = Get_Iframe_Element( 'BackChannelServerIpAddressInput' ) ;
   if ( anElement )	        // Set Server IP address
   {
      var addr1 = (aServerIpAddress & 0xFF000000) >> 24;
      var addr2 = (aServerIpAddress & 0xFF0000) >> 16;
      var addr3 = (aServerIpAddress & 0xFF00) >> 8;
      var addr4 = (aServerIpAddress & 0xFF);
      addr1 = (addr1 < 0) ? (addr1 + 256) : addr1;
      addr2 = (addr2 < 0) ? (addr2 + 256) : addr2;
      addr3 = (addr3 < 0) ? (addr3 + 256) : addr3;
      addr4 = (addr4 < 0) ? (addr4 + 256) : addr4;
      anElement.value = addr1 + "." + addr2 + "." + addr3 + "." + addr4;
      
      if ( bFeatureAutoEqInstalled )
         anElement.disabled = false;
      else
         anElement.disabled = true;
   }
}

function asyncUpdateSysBackChannelReceiveTimeoutStatus(aTimeout)
{
   var anElement = Get_Iframe_Element( 'BackChannelReceiveTimeoutInput' ) ;
   if ( anElement )	      // Set back channel receive timeout
   {  
      anElement.value = FormatNumber(aTimeout / 10, 1);
      if ( bFeatureAutoEqInstalled )
         anElement.disabled = false;
      else
         anElement.disabled = true;
   }
}

function asyncUpdateSysBackChannelReplyTimeoutStatus(aTimeout)
{
   var anElement = Get_Iframe_Element( 'BackChannelReplyTimeoutInput' ) ;
   if ( anElement )	      // Set back channel reply timeout
   {   
      anElement.value = aTimeout;
      if ( bFeatureAutoEqInstalled )
         anElement.disabled = false;
      else
         anElement.disabled = true;
   }
}

